Array.implement({
    
    intersperse: function (f) {
        var arr = this.slice(),
            len = arr.length;

        if (len <= 1) {
        	return arr;
        }

        var res = [arr[0]];
        for (var i = 1; i < len; i++) {
        	res.push(f(), arr[i]);
        }
        return res;
    }

});
var desc;
var closePops;
var currentEvent;

window.addEvent('domready', function() {
	var eventBox = $('event');
	var eventMain = $('event-main');
	var popped = false;
	var loadingInfo = false;
	var down = false;
	var stopEvent = function (ev) { ev.stop(); };
	var body = $(document.body);
	var fields = {
		title : $('event-title'),
		time : $('event-time'),
		pattern : $('event-pattern'),
		location : $('event-location'),
		description : $('event-description'),
		contact : $('contact-info'),
		sponsor : $('event-sponsor'),
		calendars : $('event-calendars'),
		imageWrapper: $('event-photo'),
		featureWrapper: $('feature'),
		unfeatureWrapper: $('unfeature'),
		eventsList: $('eventslist'),
		image : $('event-photo').getElement('img'),
		twvote: $('event-tw'),
		fbvote: $('event-fb')
	};
	var viewMore_URL = '#';
	var viewMore = new Element('a', {
		text: 'Continued...',
		href: '#',
		'class': 'continued',
		'id': 'continued-link',
		events: {
			click: function (ev) {
				ev.stop();
				eventBox.setStyle('display', 'none');
				window.location = viewMore_URL;
			}
		}
	});
	viewMore.setStyle('display', 'none');
	fields.description.grab(viewMore, 'after');
	eventBox.set('morph', {
		duration: 50,
		transition: 'quad',
		onStart: function () {
			eventBox.setStyle('overflow', 'hidden');
		},
		onComplete: function () {
			eventBox.setStyle('overflow', 'visible');
			eventMain.setStyle('display', 'block');
		}
	});
	var getSeries = function (el) {
		var classes = el.className.split(" ");
		var result = [];
		classes.each(function (c) {
			if (c.indexOf('series') === 0) {
				result = $$('.' + c);
			}
		});
		return result;
	};
	closePops = function (ev) {
		if (currentEvent != null) {
			popped = false;
			getSeries(currentEvent).each(function (e) {
				e.removeClass('current-series');
			});
			currentEvent.removeClass('popped');
			eventBox.setStyle('display', 'none');
		}
	};
	var defaultPopPosition = function (el) {
		var c = el.getCoordinates();
		var p = {left : c.left + c.width/2, top : c.top, bottom: '', position: 'absolute'};
		
		eventBox.setStyles({
			width: null,
			height: null
		});
		
		var eventBoxDimensions = eventBox.measure(function () {	return this.getComputedSize(); });
		var w = window.getSize();//windows size(stays fixed unless resized)
		var ws = window.getScroll();//get the window offset
		var eventPlacement = $('events-grid');
		
		var ePC = eventPlacement.getCoordinates();//ePC stands for event placement coordinates
		var mw = 0;
		var overshotY = p.top + eventBoxDimensions.totalHeight - (ePC.top + ePC.height + mw);
		if(overshotY > 0) {
			p.top = ePC.top.max(p.top - overshotY);
		} else if (p.top - ws.y + eventBoxDimensions.totalHeight > w.y) {//if the eventbox goes a little too far below the windows size
			window.scroll(ws.x, (p.top + eventBoxDimensions.totalHeight - w.y));//scroll by the small amount.
		} 
		var finalX = p.left;
		if (p.left + eventBoxDimensions.totalWidth > w.x) { // if it goes off the page
			finalX = p.left - eventBoxDimensions.totalWidth;
			p.left -= c.width/4 + 7;
			if( finalX < 0) {
				p.left = 0;
				finalX = 0;
				eventMain.setStyle('float', 'left');
			} else {
				eventMain.setStyle('float', 'right');
			}
		} else {
			eventMain.setStyle('float', 'left');
		}
		return {start: p, endX: finalX, dimensions: eventBoxDimensions};
	};
	var popBox = function (el, position) {
		$('event-main').fade('show');
		popped = true;
		el.addClass('popped');
		getSeries(el).each(function (e) {
			e.addClass('current-series');
		});
		var positioning = position(el);
		eventBox.setStyles(positioning.start);
		if(Browser.ie6 || Browser.ie7 || Browser.ie8) {
			eventBox.setStyles({
				width: positioning.dimensions.width,
				height: positioning.dimensions.height,
				left:positioning.endX
			});
			eventBox.setStyle('display', 'block');
		} else {
			eventBox.setStyles({
				width: 0,
				height: 0
			});
			eventBox.setStyle('display', 'block');
			eventBox.morph({
				onComplete: function () {},
				width: positioning.dimensions.width,
				height: positioning.dimensions.height,
				left: positioning.endX
			});
		}
	};
	body.addEvent('mousedown', closePops);
	$$('.event-link').each(function (el) {
		el.addEvent('mousedown', function (ev) {
			closePops(); // make sure other boxes are closed.
			currentEvent = el;
			// console.log(el.href);
			// console.log(el.href);
			loadingInfo = true;
			down = true;			
			var el_href = el.href.split('/');
			var dataString = 'series='+el_href[el_href.length-2]+'&day='+el_href[el_href.length-1];
			var r = new Request.JSON({method: 'post', onSuccess: function (d) {
			
				viewMore_URL = el.href;
				//var el_href = el.href.split('/');
				//var r = new Request.JSON({url: el.href, method: 'get', onSuccess: function (d) {
				
				//var day = el_href[el_href.length-1].replace(/-/g, "_");
				////var id = 'id_'+el_href[el_href.length-2]+'_'+day;
				//var d = event_data[id];
				//var id = 'id_'+el_href[el_href.length-2]+'_'+el_href[el_href.length-1].replace(/-/g, "_");
//	event_data[id] = raw_event_data[i];
				//$(id).getFirst().set('html', d.title);
				var f = fields;
				//console.log(d);			
				f.title.set('text', d.title);
				document.title = d.title;
				//console.log('TEST');
				var start = new Date();
				//console.log(start);
				//start.clone();
				start.parse(d.start);
				var end = new Date();
				end.parse(d.end);
				f.time.set('text', start.format('%A, %B %e, %Y'));
				f.time.grab(new Element('br'));
				if (d.allday) {
					f.time.appendText('All day');
				} else if ( end.format('%a') != start.format('%a') ){//If end day isn't the same as start day
					f.time.appendText(start.format('%l:%M%p').toLowerCase() + ' – ' + end.format('%l:%M%p').toLowerCase());
					f.time.grab(new Element('br'));
					f.time.appendText(end.format('%A, %B %e, %Y'));
				} else {
					f.time.appendText(start.format('%l:%M%p').toLowerCase() + ' – ' + end.format('%l:%M%p').toLowerCase());
				}
				f.pattern.set('text', ''); // @todo
				f.location.empty();
				f.location.appendText(d.location); // @todo
				f.location.grab(new Element('br'));
				f.location.appendText(d.buildingroom);
				
				if(d.repeat !== ''){
					f.pattern.set('text','Repeats '+d.repeat+'.');
				}
				if (d.description === '') {
					f.description.getParent().setStyle('display', 'none');
				} else {
					f.description.getParent().setStyle('display', 'block');
					f.description.set('html', d.description);
					f.description.setStyle('height', '');
					var descSize = f.description.measure(function () {
						return this.getComputedSize();
					});
					if (descSize.height > 80) {
						f.description.setStyle('height', '8.5em');
						f.description.setStyle('overflow', 'hidden');
						viewMore.setStyle('display', 'block');
					} else {
						viewMore.setStyle('display', 'none');					
					}
				}
				
				f.contact.set('text', d.contact);
				f.sponsor.set('text', d.sponsor);		
				f.fbvote.set('src',"//www.facebook.com/plugins/like.php?href="+el.href+"&send=false&layout=button_count&width=450&show_faces=false&action=like&colorscheme=light&font");
				f.twvote.set('src',"//platform.twitter.com/widgets/tweet_button.html?url="+el.href+"&counturl="+el.href+"&text=UConn Event: "+encodeURIComponent(d.title));
				
				if(f.featureWrapper){
					if(d.featured != '0'){
						f.featureWrapper.setStyle('display','none');
						f.unfeatureWrapper.setStyle('display','block');
					}
					else {
						f.featureWrapper.setStyle('display','block');
						f.unfeatureWrapper.setStyle('display','none');
					}
				}
				f.calendars.empty();
				if (d.calendars === null) {
					d.calendars = [];
				}
				var mainApproved = false;
				var cals = d.calendars.map(function (c) {
					var r = new Element('span', {text: c.title});
					if (c.main === '1') {
						r.grab(new Element('em', {text: ' (organizer)'}));
						mainApproved = (c.main_approved === '1');
					}
					if (c.approved === '0' ) {//|| c.main_approved === '0') {
						r.addClass('unapproved');
					}
					return r;
				});
				var calList = cals.intersperse(function () { return document.createTextNode(', ') });
				calList.each(function (c) { f.calendars.grab(c); });
				
				if (d.image != '') {
					f.imageWrapper.setStyle('display', 'block');
					f.image.src = d.image;
					//f.image.src = 'http://webdev1.uits.uconn.edu/images/event/' + d.image + '_95.png'; // @todo
				} else {
					f.imageWrapper.setStyle('display', 'none');					
				}
				if (d.website != '') {
					var p = new Element('p');
					p.appendText('More information available at: ');
					var web_url = d.website;
					if(web_url.substr(0,4) != 'http'){ //without http head, we should add one head.
						web_url = "http://"+d.website;
						//console.log(web_url);
					}
					p.grab(new Element('a', {href: web_url, text: d.website}));
					//console.log(web_url);
					f.description.grab(p);
				}
				if (d.admission_fee != '') {
					f.description.grab(new Element('p', {text: 'Admission Fee: ' + d.admission_fee}));
				}
				loadingInfo = false;
				if (down === false) { // wait until mouse goes up
					popBox(el, defaultPopPosition);
				}
			}}).send({data:dataString});
		 	// stop the body event from firing
			ev.stopPropagation();
			ev.preventDefault();
			return false;
		});
		el.addEvent('mouseup', function (ev) {
			if (currentEvent == el && loadingInfo === false) {
				popBox(el, defaultPopPosition);
			}
			down = false;
			//popBox(el, defaultPopPosition);
		});
		el.addEvent('click', stopEvent);
	});
	eventBox.addEvent('mousedown', function (ev) {
		ev.stopPropagation(); // stops the event from propagating to body, in turn preventing the box from being closed.
	});
});