<?php

/*Hello user, please customize the below link by following the few steps:



1) Go to http://events.uconn.edu/subscribe

2) Choose the RSS FEED option

3) Add/remove calendars of your choice

4) Click CREATE FEED

5) Copy the link and replace the $RSS_LINK variable below



Example outcome with multiple calendars selected:

$RSS_LINK = 'http://events.uconn.edu/api/rss/?calendar[]=374&calendar[]=232&calendar[]=245&calendar[]=87&calendar[]=443';

*/

//Place your own link below. Follow steps above to create it.

$RSS_LINK = 'http://events.uconn.edu/api/rss/?calendar[]=42';




//DO NOT CHANGE ANYTHING BELOW

header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header('Content-Type: text/html; charset=utf-8');
$tz = date_default_timezone_get();//get it in order to be able to restore it
date_default_timezone_set('UTC');//Do not change
include('functions.php');
//Configuration variables
if(isset($_POST['series']) && isset($_POST['day'])) {
	//var_dump((int)$_POST['series'], $_POST['day']);
	if (!preg_match('/[0-9]{4}-[0-9]{2}-[0-9]{2}/',$_POST['day'])) {
		echo('The date does not match the format YYYY-MM-DD');
		die();
	}
	if((int)$_POST['series']<=0){
		echo('Wrong series data');
		die();
	}
	$FEED_URL = 'http://events.uconn.edu/api/smallcal_ajax2/'.(int)$_POST['series'].'/'.$_POST['day'];
	//$FEED_URL = 'http://events.uconn.edu/api/rss/'.(int)$_POST['series'].'/'.$_POST['day'];
	$ch = curl_init($FEED_URL);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
	$json_event_data = curl_exec($ch);
	curl_close($ch);
	echo strip_tags($json_event_data,'<br><a><sup><sub>');//remove any harmful scripts
	die();//ajax request, kill page here
}
//Used to get the data for a calendar to display on page.
if (isset($_GET['month']) && isset($_GET['year'])){
	$date = $_GET['year'].'-'.$_GET['month'].'-01';
	$month = $_GET['month'];
	$year = $_GET['year'];
} else {
	$date = date('Y-m').'-01';
	$month = date('m');
	$year = date('Y');
}

//Generate Calendar View using RSS feed(minimal information needed)
//just to make sure we have the ? in URL for GET request
$q = '';
if(strpos($RSS_LINK,'?') === false) {
	$q = '?';
}
$FEED_URL = $RSS_LINK.$q.'&month='.$month.'&year='.$year;
$ch = curl_init($FEED_URL);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
$output = curl_exec($ch);
curl_close($ch);
//$output = utf8_encode($output);//due to issues with it somehow not being utf8

$grid = new Grid($output, $month, $year, 24);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Small Calendar</title>
<!-- <?php echo $FEED_URL; ?> -->
<link rel="stylesheet" type="text/css" href="styles/glyphicons.css">
<link rel="stylesheet" type="text/css" href="styles/screen.css">
<script type="text/javascript" src="scripts/mootools-core-1.3.2-full-nocompat.js"></script>
<script type="text/javascript" src="scripts/mootools-more.js"></script>
<script type="text/javascript" src="scripts/modernizr.js"></script>
<script type="text/javascript" src="scripts/main.js"></script>
</head>
<body>
<?php 
$grid->drawGrid();
?>
<div id="event" class="event" style="display: none"> 
	<div id="event-main" class="event-main"> 
		<div id="event-content" class="event-content"> 
			<h3 id="event-title" class="event-title"></h3> 
			<div id="event-when" class="event-when"> 
				<p id="event-time" class="event-time glyphicons clock"></p> 
				<p id="event-pattern" class="event-pattern"></p> 
			</div> 
			<div id="event-details" class="event-details"> 
				<p id="event-location" class="event-location glyphicons google_maps"><br/></p> 
			</div> 
			<div class="event-description-wrapper">
				<div id="event-description" class="event-description">
					<p></p>
                 </div>
			</div>
			<p id="event-contact" class="event-contact"><span id="contact-label" class="contact-label">Contact:</span> <span id='contact-info'></span></p> 
			<p id="event-sponsor" class="event-sponsor"></p> 
			<p id="event-calendars" class="event-calendars"></p> 
		</div> 
		<div id="event-side" class="event-side"> 
			<div id="event-photo" class="event-photo" style="display:none;"><img src="" alt="#eventtitle" height="95" width="95"/></div> 
			<div id="event-controls" class="event-controls"> 
				<div id="event-social" class="event-controlbox event-social"> 
					<ul> 
						<li>
                        	<iframe id="event-fb" class="event-fb"  scrolling="no" frameborder="0" allowTransparency="true"></iframe>
                        </li> 
						<li> 
							 
                        	<iframe id="event-tw" allowtransparency="true" class="event-tw"  frameborder="0" scrolling="no"></iframe>
                        </li> 
					</ul> 
				</div>
			</div>
		</div>
	</div>
</div>
<div id="triggertarp">
&nbsp;
</div>
<div id="detail">
&nbsp;
</div>
</body>
</html>
<?php 
date_default_timezone_set($tz);//restore timezone settings
?>